﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Threading;
using Telerik.Charting;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ChartView;
using Telerik.Windows.Data;

namespace WPFApp
{
    public partial class MainWindow : Window
    {
        public RadObservableCollection<ChartDataObject> CurrentPosValues { get; private set; }

        private readonly DispatcherTimer timer;

        private double i = 0;

        public MainWindow()
        {
            InitializeComponent();

            this.timer = new DispatcherTimer();
            this.CurrentPosValues = new RadObservableCollection<ChartDataObject>();
            timer.Tick += Timer_Tick;
            //timer.Tick += Timer_Tick2;
            timer.Interval = TimeSpan.FromMilliseconds(5);
        }

        int items = 0;

        void Timer_Tick(object sender, EventArgs e)
        {
            ChartDataObject obj = new ChartDataObject();
            obj.Date = DateTime.Now;
            obj.Value = (float)Math.Sin(i);
            i += 0.01;

            if (CurrentPosValues.Count == 1000)
            {
                CurrentPosValues.RemoveAt(0);
            }
            CurrentPosValues.Add(obj);

            if (items < 100)
            {
                CurrentPosValues.SuspendNotifications();
                items++;
            }
            else
            {
                CurrentPosValues.ResumeNotifications();
                items = 0;
            }
        }

        void Timer_Tick2(object sender, EventArgs e)
        {
            ChartDataObject obj = new ChartDataObject();
            obj.Date = DateTime.Now;
            obj.Value = (float)Math.Sin(i);
            i += 0.01;

            CurrentPosValues.SuspendNotifications();

            if (CurrentPosValues.Count == 1000)
            {
                CurrentPosValues.RemoveAt(0);
            }
            CurrentPosValues.Add(obj);

            CurrentPosValues.ResumeNotifications();
        }

        private void StartButton_Click(object sender, RoutedEventArgs e)
        {
            timer.Start();
        }

        private void StopButton_Click(object sender, RoutedEventArgs e)
        {
            timer.Stop();
        }
    }

    public class ChartDataObject
    {
        public DateTime Date { get; set; }
        public float Value { get; set; }
    }
}